﻿//########################
//InDesignCS4で開いているドキュメントを全てPDFに書き出します。
//たけうちとおる
//########################

//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;

main();
function main(){
	if (app.documents.length == 0){
			alert("ドキュメントを開いて実行してください。");
			return;
	}
	var preset_count = app.pdfExportPresets.length;
	var pdf_preset_name = new Array();
	for(var i = 0; i < preset_count; i++){
		pdf_preset_name.push(app.pdfExportPresets[i].name);
	}
	makedialog(pdf_preset_name);
}
function makedialog(pdf_preset_name){
	//ダイアログを作成する
	myDialog = app.dialogs.add({name:"開いているドキュメントを全てPDFに書き出します。"});
	with(myDialog){
		with(dialogColumns.add()){
			with(borderPanels.add()){
				with (dialogRows.add()){
					staticTexts.add({staticLabel:"PDF書き出しプリセットを選択"});
				}
				with (dialogRows.add()){
					var pdf_preset = dropdowns.add({stringList:pdf_preset_name, selectedIndex:0, minWidth:120});
				}
				with (dialogRows.add()){
					var window_close = checkboxControls.add({staticLabel:"書き出したドキュメントは閉じる", checkedState:true})
				}
			}
			staticTexts.add({staticLabel:"(C)2009 Toru Takeuchi このスクリプトはフリーウェアです。"});
		}
	}
	var myReturn = myDialog.show();
	//ここから処理を行う
	if (myReturn == true){
		pdf_preset_num = pdf_preset.selectedIndex;
		var window_close_flg = window_close.checkedState;
		myDialog.destroy();
		export_pdf(pdf_preset_num,window_close_flg);
	}
	else{
		myDialog.destroy();
	}
}

function export_pdf(export_pdf_name,window_close_flg){
	var myPDFExportPreset = app.pdfExportPresets[pdf_preset_num];
	//for(var N = 0;N < app.documents.length;N++){
	for(var N = app.documents.length - 1;N > -1 ;N--){
		var myDocu = app.documents[N];
		var myFile = app.documents[N].fullName;
		var inddPath = myFile.fullName;
		var pdfPath = inddPath.replace(".indd",".pdf");
		var pdfFile = new File(pdfPath);
		app.documents[N].exportFile(ExportFormat.pdfType, pdfFile, false,myPDFExportPreset);
		if(window_close_flg == true){
			myDocu.close(SaveOptions.NO);
		}
	}
}

